/*
 * Copyright (c) 2016,2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU Affero General
 *     Public License as published by the Free Software Foundation,
 *     either version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU Affero General Public License for more
 *     details.
 *
 *     You should have received a copy of the GNU Affero General
 *     Public License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef DATAFRAME_COMMENT_HPP
#define DATAFRAME_COMMENT_HPP 1

#include <string>
#include <dataframe/manipulator_storage_base.hpp>

namespace dataframe
{

  class comment_character
    : public manipulator_storage_base< comment_character,char >
  {
    using base = manipulator_storage_base< comment_character,char >;
    
  public:
    template < typename ... Args >
    comment_character (Args&& ... args)
      : base(std::forward<Args>(args)...)
    {}

    std::string pattern () const { return std::string(1,this->value()); }
  };

  auto comment (char c) { return comment_character(c); }
  auto comment (std::ios_base& ios_base) { return comment_character(ios_base); }
  
} // namespace dataframe

#endif
