/*
 * Copyright (c) 2016,2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU Affero General
 *     Public License as published by the Free Software Foundation,
 *     either version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU Affero General Public License for more
 *     details.
 *
 *     You should have received a copy of the GNU Affero General
 *     Public License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef GRAPH_MODEL_TRAITS_ADJACENCY_ITERATOR_HPP
#define GRAPH_MODEL_TRAITS_ADJACENCY_ITERATOR_HPP 1

#include <boost/graph/adjacency_iterator.hpp>
#include <graph_model/traits/out_edge_iterator.hpp>
#include <graph_model/traits/vertex_descriptor.hpp>

namespace graph_model
{

  namespace traits
  {

    template < typename GraphTag >
    class adjacency_iterator
    {
      using graph_type = graph_model<GraphTag>;
      using vertex_descriptor = vertex_descriptor_t<GraphTag>;
      using out_edge_iterator = out_edge_iterator_t<GraphTag>;
      using iterator = typename boost::adjacency_iterator_generator<graph_type,vertex_descriptor,out_edge_iterator>::type;

    public:
      using type = iterator;
    };

    template < typename GraphTag >
    using adjacency_iterator_t = typename adjacency_iterator<GraphTag>::type;

  } // namespace traits

} // namespace graph_model

#endif
