/*
 * Copyright (c) 2016,2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU Affero General
 *     Public License as published by the Free Software Foundation,
 *     either version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU Affero General Public License for more
 *     details.
 *
 *     You should have received a copy of the GNU Affero General
 *     Public License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef GRAPH_MODEL_TRAITS_EDGE_ITERATOR_HPP
#define GRAPH_MODEL_TRAITS_EDGE_ITERATOR_HPP 1

#include <set>
#include <graph_model/graph_tags.hpp>
#include <graph_model/traits/edge_descriptor.hpp>
#include <graph_model/edge/edge_iterator.hpp>

namespace graph_model
{

  namespace traits
  {

    template < typename GraphTag >
    struct edge_iterator
    {
      using type = void;
    };

    template <>
    class edge_iterator< tag::edge_list_graph >
    {
      using edge_descriptor = edge_descriptor_t<tag::edge_list_graph>;
      using edge_collection =  std::set<edge_descriptor>; // XXX - make generic?
      using iterator = ::graph_model::edge::edge_iterator<edge_collection>;
    public:
      using type = iterator;
    };

    template <>
    struct edge_iterator< tag::vertex_and_edge_list_graph >
      : edge_iterator< tag::edge_list_graph >
    {};

    template < typename GraphTag >
    using edge_iterator_t = typename edge_iterator<GraphTag>::type;

  } // namespace traits

} // namespace graph_model

#endif
