/*
 * Copyright (c) 2016,2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU Affero General
 *     Public License as published by the Free Software Foundation,
 *     either version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU Affero General Public License for more
 *     details.
 *
 *     You should have received a copy of the GNU Affero General
 *     Public License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef GRAPH_MODEL_TRAITS_GRAPH_TAG_HPP
#define GRAPH_MODEL_TRAITS_GRAPH_TAG_HPP 1

#include <graph_model/graph_model_fwd.hpp>

namespace graph_model
{

  namespace traits
  {

    template < typename Graph >
    class graph_tag;

    template < typename GraphTag >
    struct graph_tag< graph_model<GraphTag> >
    {
      using type = GraphTag;
    };

    template < typename Graph >
    using graph_tag_t = typename graph_tag<Graph>::type;

  } // namespace traits

} // namespace graph_model

#endif
